/*  $Id$

    Designed and implemented by Jan Wielemaker
    E-mail: jan@swi.psy.uva.nl

    Copyright (C) 1994 University of Amsterdam. All rights reserved.
*/

#ifndef _CONSOLE_H_INCLUDED
#define _CONSOLE_H_INCLUDED

#include <signal.h>

#ifndef SIGWINCH
#define SIGWINCH SIGUSR1
#endif

#define RLC_APPTIMER_ID	100		/* >=100: application timer */

#ifdef ___WIN386_INCLUDED__
HANDLE		rlc_hinstance(void);	/* hInstance of WinMain() */
HWND		rlc_hwnd(void);		/* HWND of console window */
#endif

typedef void	(*RlcUpdateHook)(void);	/* Graphics update hook */
typedef void	(*RlcTimerHook)(int);	/* Timer fireing hook */

extern RlcUpdateHook rlc_update_hook;
extern RlcTimerHook  rlc_timer_hook;

void		rlc_title(char *title);
void		rlc_dispatch(int *charaddr);
int		getch(void);
int		getche(void);
int		getkey(void);
void		ScreenInit(void);
void		ScreenGetCursor(int *row, int *col);
void		ScreenSetCursor(int row, int col);
int		ScreenCols(void);
int		ScreenRows(void);

#endif /* _CONSOLE_H_INCLUDED */
